/**************************************************************************\

							tB^[֐

  : 
    SampleFilter̃Cve[V

  o[W:

\**************************************************************************/

#include "stdafx.h"
#include "SampleFilter.h"
#include "MAapi.h"
#include <tchar.h>

typedef unsigned char byte;

#define MODULE_NAME "Sample Filter"

/**************************************************************************\
                             MAuser_function()

@F
   MAuser_function֐́AMicroAVS̃j[ł̃vOC[hꂽ
   ɃR[܂BMicroAVSŕ\f[^̕ύXsɂ́Å֐
   MicroAVSAPIR[ĂB
\**************************************************************************/
int __stdcall MAuser_function()
{

	/* F xp_long ^ 32bit ł int, 64bit ł __int64 */
	xp_long nnodes;
	int     ncomp, veclen;
	xp_long size;
	int     type;
	char*   data;
	char*   newdata;
	int     result;
	xp_long i, j;

	/* m[h̎擾 */
	result = MAget_nnodes(&nnodes);
	if(result == MAERROR)
	{
		MessageBox(NULL, _T("MAget_nnodes failed."), _T(MODULE_NAME), MB_OK);
		return 0;
	}

	/* f[^̌̎擾 */
	result = MAget_node_ncomp(&ncomp);
	if(result == MAERROR)
	{
		MessageBox(NULL, _T("MAget_node_ncomp failed."), _T(MODULE_NAME), MB_OK);
		return 0;
	}

	/* f[^̌̃[v */
	for(i = 0; i < ncomp; i++) {
		/* P̃f[^̃f[^R|[lg */
		/* {I veclen = 1 Ԃ܂B*/
		/* C[Wf[^̏ꍇ̂݁Aveclen = 4 (RGBj*/
		result = MAget_node_data_veclen(i, &veclen);
		if(result == MAERROR)
		{
			MessageBox(NULL, _T("MAset_node_veclen failed."), _T(MODULE_NAME), MB_OK);
			return 0;
		}

		/* f[^̎擾 */
		/* field ̏ꍇ int/long/byte/char/float/double Ȃǂ */
		/* ucd ̏ꍇ float ̂ */
		/* ǂ̃^CvɂΉꍇ char* ň܂ */
		if (MAget_node_data(i, &data, &size, &type) == MASUCCESS) {

			/* Vf[^̈̊m */
			/* ^CvƃTCY alloc */
			newdata = (char *)MAalloc(type, size);

			/* f[^^Cvɉď */
			if (type == MA_DTYPE_FLOAT) {
				float* val = (float *)data;
				float* newval = (float *)newdata;
				for (j = 0; j < size; j++) {
					newval[j] = val[j] * 10.0f;		/* This sample multiply x10 */
				}
			} else if (type == MA_DTYPE_DOUBLE) {
				double* val = (double *)data;
				double* newval = (double *)newdata;
				for (j = 0; j < size; j++) {
					newval[j] = val[j] * 10.0f;
				}
			} else if (type == MA_DTYPE_BYTE) {
				byte* val = (byte *)data;
				byte* newval = (byte *)newdata;
				for (j = 0; j < size; j++) {
					newval[j] = val[j] * 10;
				}
			} else if (type == MA_DTYPE_SHORT) {
				short* val = (short *)data;
				short* newval = (short *)newdata;
				for (j = 0; j < size; j++) {
					newval[j] = val[j] * 10;
				}
			} else if (type == MA_DTYPE_INT) {
				int* val = (int *)data;
				int* newval = (int *)newdata;
				for (j = 0; j < size; j++) {
					newval[j] = val[j] * 10;
				}
			} else if (type == MA_DTYPE_LONG) {
				xp_long* val = (xp_long *)data;
				xp_long* newval = (xp_long *)newdata;
				for (j = 0; j < size; j++) {
					newval[j] = val[j] * 10;
				}
			}

			/* Set New data (Replace) */
			result = MAset_node_data(i, (char*)newdata, size, type);
			if(result == MAERROR)
			{
				if (data != NULL) MAfree(data);
				if (newdata != NULL) MAfree(newdata);
				MessageBox(NULL, _T("MAset_node_data failed."), _T(MODULE_NAME), MB_OK);
				return 0;
			}

			// free
			if (data != NULL) MAfree(data);
			if (newdata != NULL) MAfree(newdata);

		} else {
			if (data != NULL) MAfree(data);
			MessageBox(NULL, _T("MAget_node_data failed."), _T(MODULE_NAME), MB_OK);
			return 0;
		}

	} /* End component loop */


	return 1;
}

/**************************************************************************\
                             MAuser_function_name()

@F
   MAuser_function_name֐́AMicroAVS̋NɁAvOC̃j[
   \镶ݒ肵܂B
\**************************************************************************/
void __stdcall MAuser_function_name(char* szFilterName)
{
	strcpy(szFilterName, MODULE_NAME);
}

